# ============================================================================
# >> IMPORTS
# ============================================================================
# Eventscripts Imports
import es

#Python Imports
import os

# Import Source Python Events from the main addon.
dm = es.import_addon('gdeathmatch')
spe = dm.spe


# ============================================================================
# >> GLOBAL VARIABLES
# ============================================================================

spawnPoints = []
pointsLoaded = False
es_gamedir = es.ServerVar('eventscripts_gamedir')

# ============================================================================
# >> LOAD & UNLOAD
# ============================================================================
def load():
    loadSpawnFile(str(es.ServerVar("eventscripts_currentmap")))

    userid = es.getuserid()

    # If there are no players on the server, stop here
    if not userid:
        return

    pointsLoaded = True

    if not spawnPoints:
        return

    loadRandomPoints(userid)

# ============================================================================
# >> GUNGAME EVENTS
# ============================================================================

def es_map_start(event_var):
    global pointsLoaded

    pointsLoaded = False
    loadSpawnFile(event_var['mapname'])

def player_activate(event_var):
    global pointsLoaded

    if pointsLoaded:
        return

    pointsLoaded = True

    if not spawnPoints:
        return

    loadRandomPoints(event_var['userid'])


# ============================================================================
# >> CUSTOM/HELPER FUNCTIONS
# ============================================================================
def loadSpawnFile(mapName):
    global spawnPoints, pointsLoaded

    spawnPoints = []
    pointsLoaded = False

    # Get spawnpoint file
    spawnFile = ('%s' % str(es_gamedir).replace('\\', '/') + '/cfg/bfg_deathmatch/spawnpoints/%s.txt' % mapName)

    # Does the file exist?
    if not os.path.isfile(spawnFile):
        return

    # Get spawnpoint lines
    spawnPointFile = open(spawnFile, 'r')
    fileLines = [x.strip() for x in spawnPointFile.readlines()]
    spawnPointFile.close()

    # Set up spawnpoints
    spawnPoints = [x.split(' ', 6) for x in fileLines]

def loadRandomPoints(userid):
    # Remove existing spawnpoints
    for tSpawn in es.createentitylist('info_player_terrorist'):
        es.server.cmd('es_xremove %s' % tSpawn)
    for ctSpawn in es.createentitylist('info_player_counterterrorist'):
        es.server.cmd('es_xremove %s' % ctSpawn)

    # Loop through the spawnpoints
    for spawn in spawnPoints:
		for team in ('info_player_terrorist', 'info_player_counterterrorist'):
			es.server.cmd('es_xgive %s %s' % (userid, team))
			index = int(es.ServerVar('eventscripts_lastgive'))
			es.setindexprop(index, 'CBaseEntity.m_vecOrigin', '%s,%s,%s' % (spawn[0], spawn[1], spawn[2]))
			es.setindexprop(index, 'CBaseEntity.m_angRotation', '%s,%s,%s' % (spawn[3], spawn[4], spawn[5]))